<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2011 Helmut Hackbarth <info@t3solution.de>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');

/**
 * Plugin 'JSliderNews' for the 't3s_jslidernews' extension.
 *
 * @author	Helmut Hackbarth <info@t3solution.de>
 * @package	TYPO3
 * @subpackage	tx_t3sjslidernews
 */
class tx_t3sjslidernews_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_t3sjslidernews_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_t3sjslidernews_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 't3s_jslidernews';	// The extension key.
	var $pi_checkCHash = true;

	var $imageWidth = '';
	var $imageHeight = '';
	var $sliderWidth = '';
	var $sliderHeight = '';
	var $marginTop = '';
	var $extPath = '';
  var $DAM = '';

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	public function main($content, $conf) {
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();

    $this->extPath = t3lib_extMgm::siteRelPath($this->extKey);
 
    $this->init();

    switch ($this->conf['contentStyle']) {
      case 'tt_news':
        $this->DAM = t3lib_extMgm::isLoaded('dam_ttnews')?'1':'';
        $sliderRecords = $this->getSliderNewsRecords();
        $content = $this->getNews($sliderRecords);
      break;
      case 'tt_content':
        $this->DAM = t3lib_extMgm::isLoaded('dam_ttcontent')?'1':'';
        $sliderRecords = $this->getSliderContentRecords();
        $content = $this->getContent($sliderRecords);
      break;
      case 'pages':
        $this->DAM = t3lib_extMgm::isLoaded('dam_pages')?'1':'';
        $sliderRecords = $this->getSliderPagesRecords();
        $content = $this->getMenu($sliderRecords);
      break;
    }

    $this->addHeaderParts();
	
		return $this->pi_wrapInBaseClass($content);
	}
	
   
	protected function init(){
    $this->pi_initPIflexForm();
		$piFlexForm = $this->cObj->data['pi_flexform'];
 		foreach ($piFlexForm['data'] as $sheet => $data) {
			foreach ($data as $lang => $value) {
				foreach ($value as $key => $val) {
						$this->conf[$key] = $this->pi_getFFvalue($piFlexForm, $key, $sheet);
        }
      }
    }
  }	


	protected function getSliderNewsRecords() {
    $select = 'tt_news.*,tt_news_cat.title AS cattitle,tt_news_cat.title_lang_ol AS cattitle_lang_ol,tt_news_cat.single_pid AS catSinglePid';
    // whereClause for the language
    $whereClause = ' AND tt_news.sys_language_uid = ' . $GLOBALS['TSFE']->sys_language_content;  
    // whereClause if only a single type of tt_news is requested (news, link-internal or link-external)
    if ($this->conf['ttnewsType'] != '3') $whereClause .= ' AND tt_news.type = '.$this->conf['ttnewsType'];
    // whereClause if a SysFolder with news-records is selected
    if ($this->conf['ttnewsSysFolder']) {
    $sysFolder = t3lib_div::trimExplode(',', $this->conf['ttnewsSysFolder']);
      if (count($sysFolder) > '1') {
        $sysFolderWhere = array();
        foreach ($sysFolder as $sF) {
          $sysFolderWhere[] = 'tt_news.pid = '.$sF;
        }         
        $sysFolderWhere = implode(' OR ', $sysFolderWhere);
        $whereClause .= ' AND ('.$sysFolderWhere.')';
      } else {
        $whereClause .= ' AND tt_news.pid = '.$this->conf['ttnewsSysFolder'];
      }         
    }
    // whereClause for the archive (display archived news or not)
    if (!$this->conf['newsArchive']) $whereClause .= ' AND (tt_news.archivedate >= '.time().' OR tt_news.archivedate = 0)';    
    // whereClause for tt_news categories to display in the slider
    if ($this->conf['sliderCat']) {
      $newsCats = t3lib_div::trimExplode(',', $this->conf['sliderCat']);
      if (count($newsCats) > '1') {
        $catWhere = array();
        foreach ($newsCats as $newsCat) {
          $catWhere[] = 'tt_news_cat_mm.uid_foreign = '.$newsCat;
        }         
        $catWhere = implode(' OR ', $catWhere);
        $whereClause .= ' AND ('.$catWhere.')';
      } else {
        $whereClause .= ' AND tt_news_cat_mm.uid_foreign = '.$this->conf['sliderCat'];
      }         
    }
    $whereClause .= $this->cObj->enableFields('tt_news_cat');
    $whereClause .= $this->cObj->enableFields('tt_news');
    $newsLimit = $this->conf['newsLimit'] ? intval($this->conf['newsLimit']) : '20';

    // default language
    if (!$GLOBALS['TSFE']->sys_language_content) {
      // DB query
      $res = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query($select, 'tt_news', 'tt_news_cat_mm', 'tt_news_cat', $whereClause, '', 'tt_news.datetime '.$this->conf['ascDesc'], $newsLimit);
      $sliderRecords = array();
      while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) { 
        $sliderRecords[$row['uid']] = $row;
        // images for the tt_news-records from dam
        if($this->DAM) {
          $sliderRecords[$row['uid']]['image'] = '';
          $damFiles = tx_dam_db::getReferencedFiles('tt_news', $row['uid'], 'tx_damnews_dam_images');
          if ($damFiles['files']) $sliderRecords[$row['uid']]['image'] = implode(',',$damFiles['files']);
        }
        // if the EXT rgnewsce is used
        if (t3lib_extMgm::isLoaded('rgnewsce') == 'TRUE' && $sliderRecords[$row['uid']]['tx_rgnewsce_ce']) {
          // if there is no image from tt_news records - use image from the first ce
          if(!$sliderRecords[$row['uid']]['image']) {
            // records from the first ce
            $ceUid = t3lib_div::trimExplode(',', $row['tx_rgnewsce_ce']);
            $ceRecord = $this->pi_getRecord('tt_content', $ceUid['0']);
            // if dam is used - get the images from dam
            if(t3lib_extMgm::isLoaded('dam_ttcontent')) {
              $damFiles = tx_dam_db::getReferencedFiles('tt_content', $ceUid['0'], 'tx_damttcontent_files');
              if ($damFiles['files']) { 
                $sliderRecordImages = implode(',',$damFiles['files']);
                $sliderRecordImages = t3lib_div::trimExplode(',', $sliderRecordImages);
                $sliderRecords[$row['uid']]['image'] = $sliderRecordImages['0'];
                $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
                if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = $sliderRecordImages['1'];
              }
            } else {
              $ceRecordImage = t3lib_div::trimExplode(',', $ceRecord['image']);
              $sliderRecords[$row['uid']]['image'] = $ceRecordImage['0'];
              $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
              if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = $ceRecordImage['1'];
            }
            // delete all the dummy.rgg images from the slider
            $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
            if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = '';
            // use the bodytext from the ce for the image
            $ceRecordBodytext = t3lib_div::trimExplode(',', $ceRecord['bodytext']);
            if ($ceRecordBodytext['0']) $sliderRecords[$row['uid']]['bodytext'] = $ceRecordBodytext['0'];
          }
        }                                               
        // if an image is required 
        if ($this->conf['requireImage'] == '1') {
          // ... delete all recoprds without an image 
          if (!$sliderRecords[$row['uid']]['image']) {
            unset($sliderRecords[$row['uid']]);
          }
        }
      }
      $GLOBALS['TYPO3_DB']->sql_free_result($res); 

    // other language
    } else {
      // DB query
      $res = $GLOBALS['TYPO3_DB']->exec_SELECT_mm_query($select, 'tt_news', 'tt_news_cat_mm', 'tt_news_cat', $whereClause, '', 'tt_news.datetime '.$this->conf['ascDesc'], $newsLimit);
      $sliderRecords = array();
      while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) { 
        $sliderRecords[$row['uid']] = $row;
        // if dam is used
        if($this->DAM) {        
          $sliderRecords[$row['uid']]['image'] = '';
          $damFiles = tx_dam_db::getReferencedFiles('tt_news', $row['uid'], 'tx_damnews_dam_images');
          if ($damFiles['files']) $sliderRecords[$row['uid']]['image'] = implode(',',$damFiles['files']);
          // if no image is found - search for an image in the orig-records (from default language)
          if (!$sliderRecords[$row['uid']]['image']) {
            $damFiles = tx_dam_db::getReferencedFiles('tt_news', $row['t3_origuid'], 'tx_damnews_dam_images');
            if ($damFiles['files']) $sliderRecords[$row['uid']]['image'] = implode(',',$damFiles['files']);
          }
        } else {
          $orgImage = $this->pi_getRecord('tt_news', $row['t3_origuid']);
          $orgImage = $orgImage['image'];
          $orgImage = t3lib_div::trimExplode(',', $orgImage);
          $sliderRecords[$row['uid']]['image'] = $orgImage['0'];
        }
        // if the EXT rgnewsce is used
      $orgRgnewsCe = $this->pi_getRecord('tt_news', $sliderRecords[$row['uid']]['t3_origuid']);
        if (t3lib_extMgm::isLoaded('rgnewsce') == 'TRUE' && $orgRgnewsCe['tx_rgnewsce_ce']) {
          // if there is no image from tt_news records - use image from the first ce
          if(!$sliderRecords[$row['uid']]['image']) {
            // if dam is used
            if(t3lib_extMgm::isLoaded('dam_ttcontent')) {
              $damFiles = tx_dam_db::getReferencedFiles('tt_content', $sliderRecords[$row['uid']]['tx_rgnewsce_ce'], 'tx_damttcontent_files');
              if ($damFiles['files']) {               
                $sliderRecordImages = implode(',',$damFiles['files']);
                $sliderRecordImages = t3lib_div::trimExplode(',', $sliderRecordImages);
                $sliderRecords[$row['uid']]['image'] = $sliderRecordImages['0'];
                // delete all the dummy.rgg images from the slider
                $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
                if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = $sliderRecordImages['1'];
                $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
                if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = '';
              }              
              // if no image is found - use image from origuid (default language)
              if(!$sliderRecords[$row['uid']]['image']) {
                $damFiles = tx_dam_db::getReferencedFiles('tt_content', $orgRgnewsCe['tx_rgnewsce_ce'], 'tx_damttcontent_files');
                if ($damFiles['files']) {
                  $sliderRecordImages = implode(',',$damFiles['files']);
                  $sliderRecordImages = t3lib_div::trimExplode(',', $sliderRecordImages);
                  $sliderRecords[$row['uid']]['image'] = $sliderRecordImages['0'];
                  $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
                  if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = $sliderRecordImages['1'];
                }
              }
            } else {
              // records from the first ce
              $orgCeUid = t3lib_div::trimExplode(',', $orgRgnewsCe['tx_rgnewsce_ce']);
              $resOrgLLCeImage = $GLOBALS['TYPO3_DB']->exec_SELECTquery('image', 'tt_content', 't3_origuid='.$orgCeUid['0']);
              $ergOrgLLCeImage = $GLOBALS['TYPO3_DB']->sql_fetch_row($resOrgLLCeImage); 
              $ceLLImage = t3lib_div::trimExplode(',', $ergOrgLLCeImage['0']);
              $sliderRecords[$row['uid']]['image'] = $ceLLImage['0'];
              $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
              if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = $ceLLImage['1'];
              $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
              if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = '';
              // if no image is found - use image from origuid (default language)
              if(!$sliderRecords[$row['uid']]['image']) {
                $orgCeRecord = $this->pi_getRecord('tt_content', $orgCeUid['0']);
                $orgCeImage = t3lib_div::trimExplode(',', $orgCeRecord['image']); 
                $sliderRecords[$row['uid']]['image'] = $orgCeImage['0'];
                $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
                if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = $ceLLImage['1'];
                $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
                if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = '';
              }
            }
            // delete all the dummy.rgg images from the slider
            $fileType = substr($sliderRecords[$row['uid']]['image'], -3);
            if ($fileType == 'rgg') $sliderRecords[$row['uid']]['image'] = '';
          }
        }
        // if tt_news type = link-internal       
        if ($sliderRecords[$row['uid']]['type'] == '1') {
          $linkRecord = $this->pi_getRecord('tt_news', $row['t3_origuid']);
          $sliderRecords[$row['uid']]['page'] = $linkRecord['page'];
        }        
        // if an image is required 
        if ($this->conf['requireImage'] == '1') {
          // ... delete all recoprds without an image 
          if (!$sliderRecords[$row['uid']]['image']) {
            unset($sliderRecords[$row['uid']]);
          }
        }
      }
      $GLOBALS['TYPO3_DB']->sql_free_result($res); 
    }

    return $sliderRecords; 
  }

	protected function getSliderContentRecords() {
    $contentElements = t3lib_div::trimExplode(',', $this->conf['contentElement']);	
    $sliderRecords = array();
    $contentID = '0';
 		foreach ($contentElements as $contentElement) {
      $select = 'uid,pid,header,bodytext,image,subheader,imagecaption,date,t3_origuid';
      $whereClause = 'uid='.$contentElement;  
      $whereClause .= ' AND (CType=\'textpic\' OR CType=\'text\')';
      $whereClause .= $this->cObj->enableFields('tt_content');
      $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select, 'tt_content', $whereClause);
      while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) { 
        $sliderRecords[$contentID] = $row;
        if($this->DAM) {
          $sliderRecords[$contentID]['image'] = '';
          $damFiles = tx_dam_db::getReferencedFiles('tt_content', $row['uid'], 'tx_damttcontent_files');
           if ($damFiles['files']) { 
            $damImages = implode(',',$damFiles['files']);
            $damImages = t3lib_div::trimExplode(',', $damImages);
            $sliderRecords[$contentID]['image'] = $damImages['0'];
          }
          $fileType = substr($sliderRecords[$contentID]['image'], -3);
          if ($fileType == 'rgg') $sliderRecords[$contentID]['image'] = $damImages['1'];
        }
        if ($GLOBALS['TSFE']->sys_language_content) {
          if (!$sliderRecords[$contentID]['image']) {
            $orgRecord = $this->pi_getRecord('tt_content', $row['t3_origuid']);
            $orgImage = $orgRecord['image'];
            if($this->DAM) {
              $damFiles = tx_dam_db::getReferencedFiles('tt_content', $row['t3_origuid'], 'tx_damttcontent_files');
              if ($damFiles['files']) { 
                $damImages = implode(',',$damFiles['files']);
                $damImages = t3lib_div::trimExplode(',', $damImages);
                $sliderRecords[$contentID]['image'] = $damImages['0'];
              }
              $fileType = substr($sliderRecords[$contentID]['image'], -3);
              if ($fileType == 'rgg') $sliderRecords[$contentID]['image'] = $damImages['1'];
            }
          }   
        }
        $sliderRecords[$contentID]['image'] = t3lib_div::trimExplode(',', $sliderRecords[$contentID]['image']);
        $sliderRecords[$contentID]['image'] = $sliderRecords[$contentID]['image']['0'];
    
        $fileType = substr($sliderRecords[$contentID]['image'], -3);
        if ($fileType == 'rgg') $sliderRecords[$contentID]['image'] = '';
      }
      $contentID++;
    }
    $GLOBALS['TYPO3_DB']->sql_free_result($res); 

    return $sliderRecords; 
  }


	protected function getSliderPagesRecords() {
    $pages = t3lib_div::trimExplode(',', $this->conf['pages']);	
    $sliderRecords = array();
    foreach ($pages as $page) {
      if ($GLOBALS['TSFE']->sys_language_content) {
        $page = str_split($page,'23');
        $page = $page['1'];
        $select = 'uid,pid,title,subtitle,abstract,media';
        $whereClause = 'uid='.$page;  
        $whereClause .= $this->cObj->enableFields('pages_language_overlay');
        $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select, 'pages_language_overlay', $whereClause);
      } else {
        $page = str_split($page,'6');
        $page = $page['1'];
        $select = 'uid,title,subtitle,abstract,media';
        $whereClause = 'uid='.$page;  
        $whereClause .= $this->cObj->enableFields('pages');
        $res = $GLOBALS['TYPO3_DB']->exec_SELECTquery($select, 'pages', $whereClause);
      }
      while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) { 
        $sliderRecords[$row['uid']] = $row;
        if ($GLOBALS['TSFE']->sys_language_content) {
          if(!$sliderRecords[$row['uid']]['media']) {
            $orgImage = $this->pi_getRecord('pages', $sliderRecords[$row['uid']]['pid']);
           $sliderRecords[$row['uid']]['media'] = $orgImage['media'];
          }
          if($this->DAM){
            $sliderRecords[$row['uid']]['media'] = '';
            $damFiles = tx_dam_db::getReferencedFiles('pages_language_overlay', $row['uid'], 'tx_dampages_files');
            if ($damFiles['files']) $sliderRecords[$row['uid']]['media'] = implode(",",$damFiles['files']);
            if(!$sliderRecords[$row['uid']]['media']) {
              $damFiles = tx_dam_db::getReferencedFiles('pages', $row['pid'], 'tx_dampages_files');
              if ($damFiles['files']) $sliderRecords[$row['uid']]['media'] = implode(",",$damFiles['files']);
            }
          }
        } else {
          if($this->DAM){
            $sliderRecords[$row['uid']]['media'] = '';
            $damFiles = tx_dam_db::getReferencedFiles('pages', $row['uid'], 'tx_dampages_files');
            if ($damFiles['files']) $sliderRecords[$row['uid']]['media'] = implode(",",$damFiles['files']);
          }
        }
      }
    }
    $GLOBALS['TYPO3_DB']->sql_free_result($res); 

    return $sliderRecords; 
  }


 	protected function getNews($sliderRecords) {
    // if dam is used - no uploadDir is necessary
    $uploadDir = $this->DAM ? '' : 'uploads/pics/';
    // if no template is loaded - use the default template
    if (!$this->conf['templateFile']) $this->conf['templateFile'] = $this->extPath.'slidernews_template.html';
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');

    $marks = $this->getSliderSize($sliderRecords);
    $n = '1';
    foreach ($sliderRecords as $key=>$record) {
      $record['title'] = htmlspecialchars($record['title']);
      $parameter = $this->conf['ttnewsSinglePid'];
      if($this->conf['catSinglePid']) $parameter = $record['catSinglePid'] ? $record['catSinglePid'] : $this->conf['ttnewsSinglePid'];
      if ($GLOBALS['TSFE']->sys_language_content) $record['uid'] = $record['t3_origuid'];
      // if tt_news type is a normal news-record
      if($record['type'] == '0' ) { 
        $linkConf = array(
          'parameter'         => $parameter,
          'additionalParams'  => '&tx_ttnews[tt_news]='.$record['uid'],
          'useCacheHash'      => '1',
          'ATagParams'        => 'class="readmore"',
          'title'             =>  $record['title']
        );
        if($this->conf['imageLink']) {
            $imageLinkConf = array(
              'parameter'         => $parameter,
              'additionalParams'    => '&tx_ttnews[tt_news]='.$record['uid'],
              'useCacheHash'        => '1',
              'ATagParams'          => 'class="imagelink"',
              'title'               =>  $record['title']
            );  
        }     
       }
      // if tt_news type is an internal-link
      if($record['type'] == '1' ) { 
        $linkConf = array(
          'parameter'         => $record['page'],
          'title'             => $record['title']
        );
        if($this->conf['imageLink']) {
            $imageLinkConf = array(
              'parameter'     => $record['page'].' -',

              'ATagParams'    => 'class="imagelink"',
              'title'         => $record['title']
            );  
        }     
      }
      // if tt_news type is an external-link
      if($record['type'] == '2' ) { 
        $linkConf = array(
          'parameter'         => $record['ext_url'],
          'title'             => $record['title']
        );

        if($this->conf['imageLink']) {
            $imageLinkConf = array(
              'parameter'           => $record['ext_url'].' -',

              'ATagParams'          => 'class="imagelink"',
              'title'             => $record['title']
            );  
        }     
      }
      $emailLinkConf = array(
        'parameter'           => $record['author_email'],
        'ATagParams'          => 'class="authoremail"',
        'title'               => $this->pi_getLL('emailTo').' '.$record['author']
      );
     
      // ... only default images - no images from the tt_news-records
      if ($this->conf['requireImage'] == '2') $record['image'] = '0';
      $imageRecord = t3lib_div::trimExplode(',', $record['image']);
      $imageConf['file'] = $uploadDir . $imageRecord['0'];
      $thumbnailConf['file'] = $uploadDir . $imageRecord['0'];

      if (!$record['image']) {
        if ($this->conf['defaultImage']) {
          $defaultImages = t3lib_div::trimExplode(',', $this->conf['defaultImage']);
          if (count($defaultImages) > '1') {
            if (!$this->conf['imageOrder']) {
              $random = rand('0',count($defaultImages) - '1');
              $defaultImage = $defaultImages[$random];
            } else {
              if (count($sliderRecords) == count($defaultImages)) {
                $key = $n - '1';
                $defaultImage = $defaultImages[$key];
              } else {
                $random = rand('0',count($defaultImages) - '1');
                $defaultImage = $defaultImages[$random];
              }
            }
          } else {
            $defaultImage = $defaultImages['0'];
          }
          $imageConf['file'] = 'uploads/tx_t3sjslidernews/'.$defaultImage;
          $thumbnailConf['file'] = 'uploads/tx_t3sjslidernews/'.$defaultImage;
        } else {
          $imageConf['file'] =  $this->extPath.'res/icons/typo3_logo.jpg';
          $thumbnailConf['file'] =  $this->extPath.'res/icons/typo3_logo.jpg';
        }
      }
      $imageConf['file.']['width'] = $this->imageWidth.'c';
      $imageConf['file.']['height'] = $this->imageHeight;
      $imageConf['stdWrap.']['addParams.']['title'] = $record['imagetitletext'];
      $imageConf['stdWrap.']['addParams.']['alt'] = $record['imagealttext'];

      $thumbnailConf['file.']['height'] = intval($this->conf['thumbnailHeight']);
      $thumbnailConf['file.']['width'] = intval($this->conf['thumbnailWidth']).'c';
#      $thumbnailConf['stdWrap.']['addParams.']['title'] = $record['imagetitletext'];
#      $thumbnailConf['stdWrap.']['addParams.']['alt'] = $record['imagealttext'];
      $thumbnailConf['stdWrap.']['addParams.']['style'] = 'margin:'.$this->marginTop.'px '.$this->marginTop.'px 0 0';

      $marksItem['###CATEGORY###'] = '<span class="category">'.$record['cattitle'].'</span>';
      $marksItem['###CATEGORY_ICON###']  = '<span class="category_icon">'.$record['cattitle'].'</span>';
      if ($GLOBALS['TSFE']->sys_language_content) {
        $cattitle_lang_ol = t3lib_div::trimExplode('|', $record['cattitle_lang_ol']);
        $lLkey = $GLOBALS['TSFE']->sys_language_content - '1';
        if ($cattitle_lang_ol[$lLkey]) {
          $marksItem['###CATEGORY###'] = '<span class="category">'.$cattitle_lang_ol[$lLkey].'</span>';
          $marksItem['###CATEGORY_ICON###']  = '<span class="category_icon">'.$cattitle_lang_ol[$lLkey].'</span>';
        }
      }
      $marksItem['###NUMBER###']  = $n;
        $marksItem['###TITLE###'] = $record['title'];
        $marksItem['###TITLELINK###']  = $this->cObj->typolink($record['title'], $linkConf);
      if ($record['author']) {
        $marksItem['###AUTHOR###']  = '<span class="author">'.$record['author'].'</span>';
        $marksItem['###AUTHOR_ICON###']  = '<span class="author_icon">'.$record['author'].'</span>';
        $marksItem['###AUTHORLINK###']  = '<span class="author">'.$record['author'].'</span>';
        $marksItem['###AUTHORLINK_ICON###']  = '<span class="author_icon">'.$record['author'].'</span>';
        if ($record['author_email']) {
          $marksItem['###AUTHORLINK###']  = '<span class="author">'.$this->cObj->typolink($record['author'], $emailLinkConf).'</span>';
          $marksItem['###AUTHORLINK_ICON###']  = '<span class="author_icon">'.$this->cObj->typolink($record['author'], $emailLinkConf).'</span>';
        }
      } else {
        $marksItem['###AUTHOR###']  =  '';
        $marksItem['###AUTHOR_ICON###']  =  '';
        $marksItem['###AUTHORLINK###']  = '';
        $marksItem['###AUTHORLINK_ICON###']  = '';
      }
      $marksItem['###DATE###'] = '<span class="date">'.strftime($this->conf['dateFormat'],$record['datetime']).'</span>';
      $marksItem['###DATE_ICON###'] = '<span class="date_icon">'.strftime($this->conf['dateFormat'],$record['datetime']).'</span>';

      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      if($this->conf['imageLink'] && !$this->conf['direction']) { 
        $marksItem['###IMAGE###'] = $this->cObj->typolink($marksItem['###IMAGE###'], $imageLinkConf);
      }

      $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.intval($this->conf['textareaWidth']).'px; top:'.intval($this->conf['textareaOffsetTop']).'px; left:'.intval($this->conf['textareaOffsetLeft']).'px;';
      $marksItem['###NAVSELECTOR-STYLE###'] = 'padding-left: '.$this->marginTop.'px;';
      $marksItem['###DESCRIPTION-BG###'] = 'lof-description_'.$this->conf['textareaBg'];
      $marksItem['###HEADER-STYLE###'] = $this->conf['fontSize'] ? 'font-size:'.intval($this->conf['fontSize']).$this->conf['fontUnit'].';' : 'font-size:120%;';
     
      if($this->conf['sliderStyle'] == '1' || $this->conf['sliderStyle'] == '4' || $this->conf['sliderStyle'] == '5') {
       $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.intval($this->conf['textareaWidth']).'px; bottom:'.intval($this->conf['textareaOffsetBottom']).'px; left:'.intval($this->conf['textareaOffsetLeft']).'px;';
      }
      if($this->conf['sliderStyle'] == '6') {
       $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->imageWidth.'px;';
      }
      if(!$this->conf['fixedLgd']) $this->conf['fixedLgd'] = '120';
      if ($record['short']) {
        $record['short'] = t3lib_div::fixed_lgd_cs($record['short'], intval($this->conf['fixedLgd']));
        $marksItem['###TEXT###'] = $record['short'] ? $record['short'] : '';
        if (strlen($record['short']) >= intval($this->conf['fixedLgd'])) {
              $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
        } else {
              $marksItem['###READMORE###']  = '';
        }
      } else {
        $record['bodytext'] = t3lib_div::fixed_lgd_cs($record['bodytext'], intval($this->conf['fixedLgd']));
        require_once(PATH_t3lib.'class.t3lib_parsehtml_proc.php');
        $bodytext_parsehtml_proc = t3lib_div::makeInstance('t3lib_parsehtml_proc');
        $record['bodytext'] = $bodytext_parsehtml_proc->TS_links_rte($record['bodytext']);
        $marksItem['###TEXT###'] = $record['bodytext'] ? $record['bodytext'] : '';
        if (strlen($record['bodytext']) >= intval($this->conf['fixedLgd'])) {
              $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
        } else {
              $marksItem['###READMORE###']  = '';
        }
      }
      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbnailConf);   		

			$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
			$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
		  $templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
		  $subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
      $n++;
    }
    $content .= $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
 
    return $content;
  }


 	protected function getContent($sliderRecords) {
    $uploadDir = $this->DAM ? '' : 'uploads/pics/';
    if (!$this->conf['templateFile']) $this->conf['templateFile'] = $this->extPath.'slidercontent_template.html';
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');

    $marks = $this->getSliderSize($sliderRecords);
    $n = '1';
 		foreach ($sliderRecords as $record) {
      $record['header'] = htmlspecialchars($record['header']);
      $linkConf = array(
        'parameter'         => $record['pid'],
        'ATagParams'        => 'class="readmore"',
        'section'           => $record['uid'], 
        'title'             =>  $record['header']
      );
      if($this->conf['imageLink']) {
        $imageLinkConf = array(
          'parameter'         => $record['pid'],
          'section'           => $record['uid'], 
          'ATagParams'        => 'class="imagelink"',
          'title' =>  $record['header']
        );
      }     
      $imageConf['file'] = $uploadDir . $record['image'];
      $thumbnailConf['file'] = $uploadDir . $record['image'];
      if (!$record['image']) {
        if ($this->conf['defaultImage']) {
          $defaultImages = t3lib_div::trimExplode(',', $this->conf['defaultImage']);
          if (count($defaultImages) > '1') {
            if (!$this->conf['imageOrder']) {
              $random = rand('0',count($defaultImages) - '1');
              $defaultImage = $defaultImages[$random];
            } else {
              if (count($sliderRecords) == count($defaultImages)) {
                $key = $n - '1';
                $defaultImage = $defaultImages[$key];
              } else {
                $random = rand('0',count($defaultImages) - '1');
                $defaultImage = $defaultImages[$random];
              }
            }
          } else {
            $defaultImage = $defaultImages['0'];
          }
          $imageConf['file'] = 'uploads/tx_t3sjslidernews/'.$defaultImage;
          $thumbnailConf['file'] = 'uploads/tx_t3sjslidernews/'.$defaultImage;
        } else {
          $imageConf['file'] =  $this->extPath.'res/icons/typo3_logo.jpg';
          $thumbnailConf['file'] =  $this->extPath.'res/icons/typo3_logo.jpg';
        }
      }
      $imageConf['file.']['width'] = $this->imageWidth.'c';
      $imageConf['file.']['height'] = $this->imageHeight;
      $imageConf['stdWrap.']['addParams.']['title'] = $record['titleText'];
      $imageConf['stdWrap.']['addParams.']['alt'] = $record['altText'];

      $thumbnailConf['file.']['height'] = intval($this->conf['thumbnailHeight']);
      $thumbnailConf['file.']['width'] = intval($this->conf['thumbnailWidth']).'c';
#      $thumbnailConf['stdWrap.']['addParams.']['title'] = $record['imagetitletext'];
#      $thumbnailConf['stdWrap.']['addParams.']['alt'] = $record['imagealttext'];
      $thumbnailConf['stdWrap.']['addParams.']['style'] = 'margin:'.$this->marginTop.'px '.$this->marginTop.'px 0 0';

      $marksItem['###NUMBER###']  = $n;
      $marksItem['###TITLE###'] = $record['header'];
      $marksItem['###TITLELINK###']  = $this->cObj->typolink($record['header'], $linkConf);
      $marksItem['###SUBTITLE###'] = $record['subheader'] ? $record['subheader'] : '';
      $marksItem['###DATE###'] = strftime($this->conf['dateFormat'],$record['date']) ? strftime($this->conf['dateFormat'],$record['date']) : '' ;
      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      if($this->conf['imageLink'] && !$this->conf['direction']) { 
          $marksItem['###IMAGE###'] = $this->cObj->typolink($marksItem['###IMAGE###'], $imageLinkConf);
      }
      $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.intval($this->conf['textareaWidth']).'px; top:'.intval($this->conf['textareaOffsetTop']).'px; left:'.intval($this->conf['textareaOffsetLeft']).'px;';
      $marksItem['###NAVSELECTOR-STYLE###'] = 'padding-left: '.$this->marginTop.'px;';
      $marksItem['###DESCRIPTION-BG###'] = 'lof-description_'.$this->conf['textareaBg'];
      $marksItem['###HEADER-STYLE###'] = $this->conf['fontSize'] ? 'font-size:'.intval($this->conf['fontSize']).$this->conf['fontUnit'].';' : 'font-size:120%;';
      if($this->conf['sliderStyle'] == '1' || $this->conf['sliderStyle'] == '4' || $this->conf['sliderStyle'] == '5') {
       $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.intval($this->conf['textareaWidth']).'px; bottom:'.intval($this->conf['textareaOffsetBottom']).'px; left:'.intval($this->conf['textareaOffsetLeft']).'px;';
      }
      if($this->conf['sliderStyle'] == '6') {
       $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->imageWidth.'px;';
      }
      if(!$this->conf['fixedLgd']) $this->conf['fixedLgd'] = '120';
      $record['bodytext'] = t3lib_div::fixed_lgd_cs($record['bodytext'], intval($this->conf['fixedLgd']));
      require_once(PATH_t3lib.'class.t3lib_parsehtml_proc.php');
      $bodytext_parsehtml_proc = t3lib_div::makeInstance('t3lib_parsehtml_proc');
      $record['bodytext'] = $bodytext_parsehtml_proc->TS_links_rte($record['bodytext']);
      $marksItem['###TEXT###'] = $record['bodytext'] ? $record['bodytext'] : '' ;
      if (strlen($record['bodytext']) >= intval($this->conf['fixedLgd'])) {
            $marksItem['###READMORE###']  = $this->cObj->typolink($this->pi_getLL('readmore'), $linkConf);
      } else {
            $marksItem['###READMORE###']  = '';
      }
      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbnailConf);   		
			$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
			$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
		  $templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
		  $subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
      $n++;
    }

    $content .= $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
 
    return $content;
  }


 	protected function getMenu($sliderRecords) {
    $uploadDir = $this->DAM ? '' : 'uploads/pics/';
    if (!$this->conf['templateFile']) $this->conf['templateFile'] = $this->extPath.'slidermenu_template.html';
    $templateFile = $this->cObj->fileResource($this->conf['templateFile']);
    $templateFile = $this->cObj->getSubpart($templateFile,'###SLIDERSTYLE_'.$this->conf['sliderStyle'].'###');

    $marks = $this->getSliderSize($sliderRecords);
    $n = '1';
 		foreach ($sliderRecords as $record) {
      $record['title'] = htmlspecialchars($record['title']);
      if ($GLOBALS['TSFE']->sys_language_content) $record['uid'] = $record['pid'];
      $linkConf = array(
        'parameter'         => $record['uid'],
        'ATagParams'        => 'class="readmore"',
        'title'             =>  $record['title']
      );
      if($this->conf['imageLink']) {
        $imageLinkConf = array(
          'parameter'         => $record['uid'],
          'ATagParams'        => 'class="imagelink"',
          'title' =>  $record['title']
        );
      }     
      $imageRecord = t3lib_div::trimExplode(',', $record['media']);
      $imageConf['file'] = $uploadDir . $imageRecord['0'];
      $thumbnailConf['file'] = $uploadDir . $imageRecord['0'];
      if (!$record['media']) {
        if ($this->conf['defaultImage']) {
          $defaultImages = t3lib_div::trimExplode(',', $this->conf['defaultImage']);
          if (count($defaultImages) > '1') {
            if (!$this->conf['imageOrder']) {
              $random = rand('0',count($defaultImages) - '1');
              $defaultImage = $defaultImages[$random];
            } else {
              if (count($sliderRecords) == count($defaultImages)) {
                $key = $n - '1';
                $defaultImage = $defaultImages[$key];
              } else {
                $random = rand('0',count($defaultImages) - '1');
                $defaultImage = $defaultImages[$random];
              }
            }
          } else {
            $defaultImage = $defaultImages['0'];
          }
          $imageConf['file'] = 'uploads/tx_t3sjslidernews/'.$defaultImage;
          $thumbnailConf['file'] = 'uploads/tx_t3sjslidernews/'.$defaultImage;
        } else {
          $imageConf['file'] =  $this->extPath.'res/icons/typo3_logo.jpg';
          $thumbnailConf['file'] =  $this->extPath.'res/icons/typo3_logo.jpg';
        }
      }
      $imageConf['file.']['width'] = $this->imageWidth.'c';
      $imageConf['file.']['height'] = $this->imageHeight;
      $imageConf['stdWrap.']['addParams.']['title'] = $record['titleText'];
      $imageConf['stdWrap.']['addParams.']['alt'] = $record['altText'];

      $thumbnailConf['file.']['height'] = intval($this->conf['thumbnailHeight']);
      $thumbnailConf['file.']['width'] = intval($this->conf['thumbnailWidth']).'c';
#      $thumbnailConf['stdWrap.']['addParams.']['title'] = $record['imagetitletext'];
#      $thumbnailConf['stdWrap.']['addParams.']['alt'] = $record['imagealttext'];
      $thumbnailConf['stdWrap.']['addParams.']['style'] = 'margin:'.$this->marginTop.'px '.$this->marginTop.'px 0 0';
 
      $marksItem['###NUMBER###']  = $n;
      $marksItem['###TITLE###'] = $record['title'];
      $marksItem['###TITLELINK###']  = $this->cObj->typolink($record['title'], $linkConf);
      $marksItem['###SUBTITLE###'] = $record['subtitle'] ? $record['subtitle'] : '';
      $marksItem['###TEXT###'] = $record['abstract'] ? $record['abstract'] : '';

      $marksItem['###IMAGE###'] = $this->cObj->IMAGE($imageConf);
      if($this->conf['imageLink'] && !$this->conf['direction']) { 
          $marksItem['###IMAGE###'] = $this->cObj->typolink($marksItem['###IMAGE###'], $imageLinkConf);
      }
      $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.intval($this->conf['textareaWidth']).'px; top:'.intval($this->conf['textareaOffsetTop']).'px; left:'.intval($this->conf['textareaOffsetLeft']).'px;';
      $marksItem['###NAVSELECTOR-STYLE###'] = 'padding-left: '.$this->marginTop.'px;';
       $marksItem['###DESCRIPTION-BG###'] = 'lof-description_'.$this->conf['textareaBg'];
      $marksItem['###HEADER-STYLE###'] = $this->conf['fontSize'] ? 'font-size:'.intval($this->conf['fontSize']).$this->conf['fontUnit'].';' : 'font-size:120%;';
       if($this->conf['sliderStyle'] == '1' || $this->conf['sliderStyle'] == '4' || $this->conf['sliderStyle'] == '5') {
       $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.intval($this->conf['textareaWidth']).'px; bottom:'.intval($this->conf['textareaOffsetBottom']).'px; left:'.intval($this->conf['textareaOffsetLeft']).'px;';
      }
      if($this->conf['sliderStyle'] == '6') {
       $marksItem['###DESCRIPTION-STYLE###'] = 'width:'.$this->imageWidth.'px;';
      }
      $marksItem['###THUMBNAIL###'] = $this->cObj->IMAGE($thumbnailConf);   		
			$templateFileItem = $this->cObj->getSubpart($templateFile,'###SLIDER###');		
			$subpartContentArray['###SLIDER###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
		  $templateFileItem = $this->cObj->getSubpart($templateFile,'###NAVIGATION###');		
		  $subpartContentArray['###NAVIGATION###'] .= $this->cObj->substituteMarkerArrayCached($templateFileItem,$marksItem);
      $n++;
    }

    $content .= $this->cObj->substituteMarkerArrayCached($templateFile, $marks, $subpartContentArray);    
 
    return $content;
  }


 	protected function getSliderSize($sliderRecords) {
    if (!$this->conf['navigatorHeight']) {
      $this->conf['navigatorHeight'] = '100';
      if ($this->conf['sliderStyle'] == '6') $this->conf['navigatorHeight'] = '60';
    }
    if (!$this->conf['navigatorWidth']) $this->conf['navigatorWidth'] = '310';
    if (!$this->conf['thumbnailSize']) $this->conf['thumbnailSize'] = '60';
    $this->conf['navigatorHeight'] = t3lib_div::intInRange($this->conf['navigatorHeight'], '40', '100');
    $this->conf['navigatorWidth'] = t3lib_div::intInRange($this->conf['navigatorWidth'], '40', '400');
    $this->conf['thumbnailHeight'] = t3lib_div::intInRange($this->conf['thumbnailSize'], 20, $this->conf['navigatorHeight'] - '14');
    $this->conf['thumbnailWidth'] = $this->conf['thumbnailHeight'];

    $this->sliderWidth = intval($this->conf['sliderWidth']);
    if (!$this->conf['sliderWidth']) $this->sliderWidth = '700';
    $this->sliderHeight = intval($this->conf['sliderHeight']);
    if (!$this->conf['sliderHeight']) $this->sliderHeight = '300';

    if (!$this->conf['textareaWidth']) {
      $this->conf['textareaWidth'] = '350';
      // 20 = 2 x 10px padding in css
      if ($this->conf['sliderStyle'] == '5') $this->conf['textareaWidth'] = $this->sliderWidth - '20';
    }
    if (!$this->conf['textareaOffsetBottom']) {
      $this->conf['textareaOffsetBottom'] = '50';
      if ($this->conf['sliderStyle'] == '5') $this->conf['textareaOffsetBottom'] = '0';
    }
    if (!$this->conf['textareaOffsetLeft']) {
      $this->conf['textareaOffsetLeft'] = '0';
      if ($this->conf['sliderStyle'] == '3') $this->conf['textareaOffsetLeft'] = '20';
    }
    if ($this->conf['sliderStyle'] == '2' || $this->conf['sliderStyle'] == '3' || $this->conf['sliderStyle'] == '555' || $this->conf['sliderStyle'] == '6') { 
      if ($this->conf['sliderStyle'] == '6') {
       if ($this->conf['maxItemDisplay'] < '6') $this->conf['maxItemDisplay'] = '6'; 
      }
      $this->sliderHeight = $this->conf['maxItemDisplay'] * intval($this->conf['navigatorHeight']);
      // 4 = padding 3px + border 1px
      $this->marginTop = intval(($this->conf['navigatorHeight'] - $this->conf['thumbnailHeight']) / '2' - '4');
      if (!$this->conf['textareaOffsetTop']) $this->conf['textareaOffsetTop'] = '150'; 
    }
    $this->imageWidth = $this->sliderWidth;
    $this->imageHeight = $this->sliderHeight;

    if ($this->conf['sliderStyle'] == '2' || $this->conf['sliderStyle'] == '555') {
      $this->imageWidth = $this->sliderWidth - intval($this->conf['navigatorWidth']) + '15';
    } 
    if ($this->conf['sliderStyle'] == '6') {
      $this->imageWidth = $this->sliderWidth - intval($this->conf['navigatorWidth']) - '30';
      $this->imageHeight = $this->sliderHeight - '190';
    } 
    if ($this->conf['sliderStyle'] == '3') {
      $this->imageWidth = $this->sliderWidth - intval($this->conf['navigatorWidth']) + '17';
    }
    if ($this->conf['sliderStyle'] == '1') {
      if (!$this->conf['proportion']) $this->conf['proportion'] = '10';   
      $thumbnailWidth  = $this->imageWidth / intval($this->conf['proportion']);
      $this->conf['thumbnailWidth']  = intval($thumbnailWidth);
      $thumbnailHeight  = $this->imageHeight / $this->conf['proportion'];
      $this->conf['thumbnailHeight']  = intval($thumbnailHeight);
    }
    $marks['###CSS3###'] = $this->conf['css3'] ? 'lof-css3' : '';
    $marks['###CEID###'] = $this->cObj->data['uid'];
    $marks['###SLIDERWIDTH###'] = $this->sliderWidth;
    $marks['###SLIDERHEIGHT###'] = $this->sliderHeight;
    $marks['###IMAGEWIDTH###'] = $this->imageWidth;
    $marks['###IMAGEHEIGHT###'] = $this->imageHeight;
    if ($this->conf['sliderStyle'] == '6') {
        $marks['###IMAGEWIDTH###'] = $this->imageWidth + '30';
        $marks['###IMAGEHEIGHT###'] = $this->imageHeight + '30';
    }
    $marks['###ACTNAVCOLOR###'] = $this->conf['activeNavBg'];
    $marks['###ARROW-STYLE###'] = '';
    $marks['###NAVIGATOR-BG###'] = '';
    $marks['###NAV-POSITION###'] = '';
    if($this->conf['sliderStyle'] == '1') {
      $navigatorHeight = $this->conf['thumbnailHeight'] + '6';
      $navigatorWidth = $this->conf['thumbnailWidth'] + '10';
      $marks['###ARROW-STYLE###'] = $this->conf['verticalNav'] ? 'height:22px; width:'.$navigatorWidth.'px;' : 'height:'.$navigatorHeight.'px; width:22px;';
      if ($this->conf['noArrows'])$marks['###ARROW-STYLE###'] = '';
      $marks['###NAVIGATOR-BG###'] = 'lof-navigator-wapper_'.$this->conf['textareaBg'];
      $marks['###NAV-POSITION###'] = $this->conf['verticalNav'] ? 'lof-vertical' : 'lof-horizontal';
    }

    return $marks;
  }


  protected function addHeaderParts() {
    $extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf']['t3s_jslidernews']);
    if ($extConf['jqueryNoConflict']) {
      $queryNoConflict = 'jQuery.noConflict();';
    } else {
      $queryNoConflict = '';
    } 
    $pagerender = $GLOBALS['TSFE']->getPageRenderer();
    // checks if t3jquery is loaded
    if (t3lib_extMgm::isLoaded('t3jquery')) {
      require_once(t3lib_extMgm::extPath('t3jquery').'class.tx_t3jquery.php');
    }
    // if t3jquery is loaded and the custom Library had been created
    if (T3JQUERY === true) {
      tx_t3jquery::addJqJS();
    } else {
      if ($extConf['includeJquery']) {
        $pagerender->addJsLibrary(' jQuery JavaScript Library ','https://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js', 'text/javascript', TRUE, FALSE, '');
      }
      if($extConf['includeJqueryEasing']) {
        $pagerender->addJsFile($this->extPath.'res/js/jquery.easing.js', 'text/javascript', TRUE, FALSE, '');
      }
    }
    $pagerender->addJsFile($this->extPath.'res/js/jslidernews.js', 'text/javascript', TRUE, FALSE, '');

    $ceid = $this->cObj->data['uid'];  
    if (!$this->conf['duration']) $this->conf['duration'] = '1200'; 
    $this->conf['auto'] = $this->conf['auto'] ? 'true' : 'false';
    if (!$this->conf['interval']) $this->conf['interval'] = '4000'; 
    $direction = $this->conf['direction'] ? 'opacity' : ''; 

    switch ($this->conf['sliderStyle']) {
      case '1':
        $navigatorHeight = $this->conf['verticalNav'] ? $this->conf['thumbnailHeight'] + '9' : $this->conf['thumbnailHeight'] + '6';
        $navigatorWidth = $this->conf['thumbnailWidth'] + '10';
        $navPosition = $this->conf['verticalNav'] ? 'vertical' : 'horizontal';
        $js = $queryNoConflict.'jQuery(document).ready( function(){          
          var buttons = { previous:jQuery(\'#lofslidecontent'.$ceid.' .lof-previous\') ,
          next:jQuery(\'#lofslidecontent'.$ceid.' .lof-next\') };
          $obj = jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
          interval        : '.intval($this->conf['interval']).',      
          easing          : \''.$this->conf['easing'].'\',
          duration        : '.intval($this->conf['duration']).',
          auto            : '.$this->conf['auto'].',
          maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
          navPosition     : \''.$navPosition.'\',
          navigatorHeight : '.$navigatorHeight.',
          navigatorWidth  : '.$navigatorWidth.',
          mainWidth       : '.$this->sliderWidth.',
          direction       : \''.$direction.'\',
          buttons         : buttons} );  
        });';
       break;
      case '2':
        $js = $queryNoConflict.'jQuery(document).ready( function(){          
          jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
          interval        : '.intval($this->conf['interval']).',
          easing          : \''.$this->conf['easing'].'\',
          maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
          navigatorHeight : '.$this->conf['navigatorHeight'].',
          navigatorWidth  : '.$this->conf['navigatorWidth'].',
          duration        : '.intval($this->conf['duration']).',
          mainWidth       : '.$this->imageWidth.',
          direction       : \''.$direction.'\',
          auto            : '.$this->conf['auto'].' } );                                                                   
        });';
      break;
      case '3':
        $js = $queryNoConflict.'jQuery(document).ready( function(){          
          jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
          interval        : '.intval($this->conf['interval']).',
          easing          : \''.$this->conf['easing'].'\',
          maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
          navigatorHeight : '.$this->conf['navigatorHeight'].',
          navigatorWidth  : '.$this->conf['navigatorWidth'].',
          mainWidth       : '.$this->imageWidth.',
          duration        : '.intval($this->conf['duration']).',
          direction       : \''.$direction.'\',
          auto            : '.$this->conf['auto'].' } );                                                                                   
        });';
      break;
      case '4':
        $js = $queryNoConflict.'jQuery(document).ready( function(){          
          $obj = jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
          interval        : '.intval($this->conf['interval']).',
          easing          : \''.$this->conf['easing'].'\',
          duration        : '.intval($this->conf['duration']).',
          auto            : '.$this->conf['auto'].',
          maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
          navPosition     : \'horizontal\',
          navigatorHeight : 15,
          navigatorWidth  : 25,
          direction       : \''.$direction.'\',
          mainWidth       : '.$this->sliderWidth.'} );              
        });';
     break;
      case '555':
        $js = $queryNoConflict.'jQuery(document).ready( function(){                                                      
          jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
          interval        : '.intval($this->conf['interval']).',
          auto            : '.$this->conf['auto'].',
          navigatorHeight : '.$this->conf['navigatorHeight'].',
          navigatorWidth  : '.$this->conf['navigatorWidth'].',
          maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
          mainWidth       : '.$this->imageWidth.',
          duration        : '.intval($this->conf['duration']).',
          direction       : \''.$direction.'\',
          easing          : \''.$this->conf['easing'].'\'} );                                                                                        
        });';
      break;
      case '5':
        $js = $queryNoConflict.'jQuery(document).ready( function(){          
          var buttons = { previous:jQuery(\'#lofslidecontent'.$ceid.' .lof-previous\') ,
          next:jQuery(\'#lofslidecontent'.$ceid.' .lof-next\') };
          $obj = jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
          interval        : '.intval($this->conf['interval']).',
          easing          : \''.$this->conf['easing'].'\',
          maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
          duration        : '.intval($this->conf['duration']).',
          auto            : '.$this->conf['auto'].',
          mainWidth       : '.$this->sliderWidth.',
          direction       : \''.$direction.'\',
          buttons         : buttons} );  
        });';
      break;
      case '6':
      $this->imageWidth = $this->imageWidth + '30';
        $js = $queryNoConflict.'jQuery(document).ready( function(){          
          jQuery(\'#lofslidecontent'.$ceid.'\').lofJSidernews( {
          interval        : '.intval($this->conf['interval']).',
          auto            : '.$this->conf['auto'].',
          navigatorHeight : '.$this->conf['navigatorHeight'].',
          navigatorWidth  : '.$this->conf['navigatorWidth'].',
          maxItemDisplay  : '.$this->conf['maxItemDisplay'].',
          mainWidth       : '.$this->imageWidth.',
          duration        : '.intval($this->conf['duration']).',
          direction       : \''.$direction.'\',
          easing          : \''.$this->conf['easing'].'\'} );                                                                                        
        });';
      break;
     }

    $file = $this->conf['cssFile'] ? $this->conf['cssFile'] : $this->extPath.'res/css/style'.$this->conf['sliderStyle'].'.css';
    $pagerender->addCssFile($file, $rel = 'stylesheet', $media = 'all', $title = 'stylesheet',	$compress = TRUE,	$forceOnTop = FALSE, $allWrap = ''); 

    $name=' JavaScript for EXT '.$this->extKey.' CE-'.$ceid.' ';
    if ($extConf['moveJsFromFooterToHeader']){
      $pagerender->addJsInlineCode($name,$js);
    }else{
      $pagerender->addJsFooterInlineCode($name,$js);
    };
  }
}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s_jslidernews/pi1/class.tx_t3sjslidernews_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/t3s_jslidernews/pi1/class.tx_t3sjslidernews_pi1.php']);
}

?>